
CREATE TABLE ZMiscData (
  ObjId int4 DEFAULT '0' NOT NULL,
  OClass varchar(15) DEFAULT '' NOT NULL,
  MId varchar(30) DEFAULT '' NOT NULL,
  Value_int int4,
  Value_string text,
  PRIMARY KEY (ObjId,OClass,MId)
);

CREATE TABLE ZRoles (
  Id int4,
  Rolename varchar(20) DEFAULT '' NOT NULL,
  Realm varchar(10) DEFAULT '' NOT NULL,
  PRIMARY KEY (Id),
  UNIQUE (Realm,Rolename)
);
CREATE SEQUENCE ZRoles_seq;

CREATE TABLE ZSessions (
  Id int4,
  Id_User int4 DEFAULT '0' NOT NULL,
  PRIMARY KEY (Id)
);
CREATE SEQUENCE ZSessions_seq CYCLE;

CREATE TABLE ZTokens (
  Id int4 DEFAULT '0' NOT NULL,
  Class varchar(15) DEFAULT '' NOT NULL,
  Value varchar(50),
  Created numeric(16,4) DEFAULT '0.0000' NOT NULL,
  Accessed numeric(16,4) DEFAULT '0.0000' NOT NULL,
  Timeout int4 DEFAULT '0' NOT NULL,
  Life int4 DEFAULT '0' NOT NULL,
  Realm varchar(10) DEFAULT '' NOT NULL,
  PRIMARY KEY (Id,Class)
);

CREATE TABLE ZUserRoles (
  Id_User int4 DEFAULT '0' NOT NULL,
  Id_Role int4 DEFAULT '0' NOT NULL,
  PRIMARY KEY (Id_User,Id_Role)
);
CREATE INDEX Id_User_ZUserRoles_index on ZUserRoles(Id_User);
CREATE INDEX Id_Role_ZUserRoles_index on ZUserRoles(Id_Role);


CREATE TABLE ZUsers (
  Id int4,
  Username varchar(60) DEFAULT '' NOT NULL,
  Realname varchar(50),
  Password varchar(20),
  PasswordType int4 DEFAULT '0' NOT NULL,
  Domains varchar (160) DEFAULT '' NOT NULL,
  Realm varchar(10) DEFAULT '' NOT NULL,
  EMail varchar(60),
  PRIMARY KEY (Id),
  UNIQUE (Realm,Username)
);
CREATE SEQUENCE ZUsers_seq;

CREATE TABLE ZLog (
  Id int4,
  Realm varchar(10) DEFAULT '' NOT NULL,
  Id_Session int4,
  Event varchar(10) DEFAULT '' NOT NULL,
  EValue varchar(200),
  EValue2 varchar(200),
  OType varchar(30),
  OSize int4,
  RAddr varchar (15),
  Time timestamp default current_timestamp,
  PRIMARY KEY (Id)
);
CREATE SEQUENCE ZLog_seq CYCLE;

